#!/bin/sh

if [ -x "/usr/bin/perl" ]; then
        PERL=/usr/bin/perl
elif [ -x "/opt/VRTSperl/bin/perl" ]; then
        PERL=/opt/VRTSperl/bin/perl
else
        PERL=`/usr/bin/which perl | /usr/bin/grep -v '^no'`
        if [ -z "$PERL" ]; then
                echo "Cannot find a version of perl to execute script"
                exit 1
        fi
fi
eval 'exec $PERL -x -S $0 ${1+"$@"}'
        if 0;
#!perl

if($#ARGV < 0)
{
	exit 1;
}
elsif($ARGV[0] =~ /^-devices/)
{
	getDeviceGroups();
	exit 0;	
}
elsif($ARGV[0] =~ /^-shadowinfo/)
{
	shift;
	$inst = shift;
	$dgname = shift;
	$out = `HORCC_MRCF=1; export HORCC_MRCF; HORCMINST=$inst; export HORCMINST; /HORCM/usr/bin/pairvolchk -g $dgname`;
	print($out);
	exit 0;
}
elsif($ARGV[0] =~ /^-dginfo/)
{
        shift;
        $inst = shift;
        $dgname = shift;
	$out = `unset HORCC_MRCF; HORCMINST=$inst; export HORCMINST; /HORCM/usr/bin/pairdisplay -g $dgname -l`;
	print($out);
        exit 0;
}
else
{
	exit 1;
}

sub getDeviceGroups
{
	@instances = getInstances();
	foreach $inst(@instances)
	{
		getDevices($inst);
	}	
}

sub getInstances
{
	my @inst;
	open(INST, "/usr/bin/ps -e args | /usr/bin/grep horcmd | /usr/bin/grep -v grep |");
	while($line = <INST>)
	{
		chomp($line);
		#$line =~ s/^\s//;
		#$line =~ s/\s+$//;
		$line =~ s/.*horcmd_0//;
		push(@inst, $line);
	}
	return @inst;
}

sub getDevices
{
	my $inst = shift;
	my $filename = "/etc/horcm" . $inst . ".conf";
	return if(! -f $filename);
	open(DG, "< $filename");
	while($line = <DG>)
	{
		chomp($line);
		$line =~ s/^\s//;
                $line =~ s/\s+$//;
		last if($line =~ /HORCM_INST/);
	}
	while($line = <DG>)
	{
		chomp($line);
                $line =~ s/^\s//;
                $line =~ s/\s+$//;
		next if($line =~ /^#/);
		next if($line eq "");
		@tok = split(/\s+/, $line);
		print("$tok[0] $inst /HORCM/usr/bin\n");
	}
}
